angular.module('Qaidi.controllers',[])



// Language Controller
.controller('LanguageCtrl', function($scope,$rootScope, $stateParams,$translate,SettingsStorage,$window,NodePushServer,Device_id_Storage) {

 $scope.setLang = function(langKey) {
	var LocalDeviceID =Device_id_Storage.get();	
  if(LocalDeviceID ){NodePushServer.removeDeviceToken(LocalDeviceID,$rootScope.lang_url);}
    // You can change the language during runtime
    $translate.use(langKey);
	var settings_values= {
            // set languge first time
       
            lang: langKey,
            nots:true
        };
    SettingsStorage.save_lang(settings_values);
$window.location.href = '#app/home';
	$window.location.reload(true);

  };  
  
})

// Radio Controller
.controller('RadioCtrl', function($scope, $cordovaMedia,$ionicLoading) {

})
// Home Controller
.controller('HomeCtrl', function($scope,$translate,$timeout,$ionicPlatform, $ionicScrollDelegate, $ionicLoading,LatestPostData, LatestPostStorage, CatsData, CatsDataStorage, $http,$sce) {


    $scope.cats = [];
    $scope.catpostLimit = 3;
    $scope.posts = [];
	$scope.loading = $ionicLoading.show({
    template: '<i class="icon ion-loading-c"></i> '+ $translate.instant('MrQaidi.loading'),
      //Will a dark overlay or backdrop cover the entire view
      showBackdrop: false,
      // The delay in showing the indicator
      showDelay: 5
    });
    $ionicPlatform.on('resume', function() {
		console.log("on resume  started ");
       GetLatestPost();	
		GetCats();	
    });
	var GetLatestPost = function() {
	LatestPostData.async().then(
        // successCallback
        function() {
            $scope.posts = LatestPostData.getAll();
            $ionicLoading.hide();
        },
        // errorCallback 
        function() {
            $scope.posts = LatestPostStorage.all();
            $ionicLoading.hide();
        },
        // notifyCallback
        function() {}
    );	

	}
	var GetCats = function() {
	CatsData.async().then(
        // successCallback
        function() {
            $scope.cats = CatsData.getAll();
            $ionicLoading.hide();

        },
        // errorCallback 
        function() {
            $scope.cats = CatsDataStorage.all();
            $ionicLoading.hide();

        },
        // notifyCallback
        function() {}
    );	
	}
GetLatestPost();	
GetCats();	

 $scope.trustSrc = function(src) {
    return $sce.trustAsResourceUrl(src);
  }
  
})








// Post Controller
.controller('PostCtrl', function($scope,$ionicLoading,$translate, $stateParams, PostData, $sce) {
	    $scope.post = {};

	$scope.loading = $ionicLoading.show({
      template: '<i class="icon ion-loading-c"></i> '+ $translate.instant('MrQaidi.loading'),

      //Will a dark overlay or backdrop cover the entire view
      showBackdrop: false,

      // The delay in showing the indicator
      showDelay: 5
    });
	//call the service like this
	PostData.get($stateParams.postId).then(function(res){
	    				//alert(res.title);
						
				//console.log(res.data);
    $scope.content = $sce.trustAsHtml(res.data.content);

  $scope.post = res.data;
  $scope.post.date= Date.parse($scope.post.date);
  $ionicLoading.hide();    

	});

    
    $scope.loadURL = function (url) {
        //target: The target in which to load the URL, an optional parameter that defaults to _self. (String)
        //_self: Opens in the Cordova WebView if the URL is in the white list, otherwise it opens in the InAppBrowser.
        //_blank: Opens in the InAppBrowser.
        //_system: Opens in the system's web browser.
        window.open(url,'_blank');
    }
    
    $scope.sharePost = function () {

        var subject = $scope.post.title;
        var message = $scope.post.content;
        message = message.replace(/(<([^>]+)>)/ig,"");

        var link = $scope.post.url;

        //Documentation: https://github.com/EddyVerbruggen/SocialSharing-PhoneGap-Plugin
        //window.plugins.socialsharing.share('Message', 'Subject', 'Image', 'Link');
        window.plugins.socialsharing.share(message, subject, null, link);
    }
})



// RSS Feeds Controller
.controller('CatCtrl', function($scope,$translate,$http, $ionicLoading,$stateParams,WORDPRESS_API_URL,$rootScope) {
	//alert($stateParams.catId);
	var lang_url = $rootScope.lang_url;
    var json_url = WORDPRESS_API_URL+'/'+$rootScope.lang_url+'/index.php?option=com_qaidi_app&task=Urls&opt=k2_cat_items&catid='+$stateParams.catId;

	$scope.loading = $ionicLoading.show({
    template: '<i class="icon ion-loading-c"></i> '+ $translate.instant('MrQaidi.loading'),
      //Will a dark overlay or backdrop cover the entire view
      showBackdrop: false,
      // The delay in showing the indicator
      showDelay: 5
    });
    $scope.LimitNum = 10;

  	$scope.posts = [];
	
	
var GetPOSTS = function() {
$http({method: 'GET', url: json_url , timeout: 5000}).
        // this callback will be called asynchronously
        // when the response is available.
        success(function(data) {
			

			 $ionicLoading.hide();

			  $scope.cat_title =  data.catname;  
			  $scope.posts = angular.fromJson(data);      
			  $scope.postsCounts = _.size( $scope.posts)-3;      
			  console.log($scope.postsCounts);

			});
  }
  
  
GetPOSTS();

	var page = 1;
    // Define the number of the posts in the page
    var pageSize = 10;

    $scope.paginationLimit = function(data) {
    return pageSize * page;
    };

    $scope.hasMoreItems = function() {
    return page < ($scope.postsCounts / pageSize);
    };

    $scope.showMoreItems = function() {
    page = page + 1;       
    }; 
 })  
// main Control
.controller('AppCtrl', function($scope,$rootScope,$location,$http, $ionicModal,$ionicSideMenuDelegate,$ionicLoading, $timeout, $ionicActionSheet,CatsData, CatsDataStorage,WORDPRESS_API_URL) {
$scope.kbHide =   function() {
    cordova.plugins.Keyboard.close();
  }
 // directive configuration object
    $scope.options = {
        shadowInput: true,
        highlightFirst: true,       
        searchMethod: "search",
      //  templateUrl: "demoTemplate.html"
    };
    

    $scope.search = function (query, deferred) {       	
        var json_url = WORDPRESS_API_URL+"/"+$rootScope.lang_url+"/index.php?option=com_qaidi_app&task=Urls&opt=search_api&s=" + query + "&limit=5";

		$http.get(json_url).success((function (deferred, data) { // send request          
            // format data into desired structure
			var results = [];
			data.query.forEach(function (item) { 
                results.push({value: item.title,                    
				post_id: item.post_id
				}); 
            });	
            // resolve the deferred object
			deferred.resolve({results: results});
		}).bind(this, deferred));
	};    
	// on select go to post
	$rootScope.$on('sznAutocomplete-select', function(event, e){
		 $location.path("/app/post/"+e.itemData.post_id);
		if($rootScope.rtl === "right"){
			
			    $ionicSideMenuDelegate.toggleRight();			
		}else{
		    $ionicSideMenuDelegate.toggleLeft();	
		}
		});

CatsData.async().then(
        // successCallback
        function() {
            $scope.cats = CatsData.getAll();
            $ionicLoading.hide();
        },
        // errorCallback 
        function() {
            $scope.cats = CatsDataStorage.all();
            $ionicLoading.hide();
        },
        // notifyCallback
        function() {}
    );

})
// Seetings Controller
.controller('SettingsCtrl', function($scope,$translate, SettingsStorage,Device_id_Storage,NodePushServer,$rootScope) {
 $scope.$on('$ionicView.beforeEnter', function (event, viewData) {
    viewData.enableBack = true;
});
    $scope.settings = SettingsStorage.all();
console.log($scope.settings.lang);

    $scope.saveSettings = function() {
        SettingsStorage.save($scope.settings);
    };
    
    $scope.$watch('settings', function() { SettingsStorage.save($scope.settings) }, true);
    
  $scope.setLang = function(langKey) {
	  if(langKey =="ku"){
		      $scope.old_url = "arabic";
	  }else{
	$scope.old_url = "kurdish";
  
	  }
	  	var LocalDeviceID =Device_id_Storage.get();	
		if(LocalDeviceID !==0){
			NodePushServer.removeDeviceToken(LocalDeviceID,$scope.old_url);
			
			}
    // You can change the language during runtime
    $translate.use(langKey);
	var settings_values= {
            // set languge first time
       
            lang: langKey,
            nots:true
        };
    SettingsStorage.save_lang(settings_values);
    $scope.settings.lang = langKey;

  };
    

    
})

