angular.module('QaidiCMS.factories', [])



// Factory for node-pushserver (running locally in this case), if you are using other push notifications server you need to change this
.factory('NodePushServer', function ($http,WORDPRESS_API_URL,$rootScope,Device_id_Storage){
  // Configure push notifications server address
  // 		- If you are running a local push notifications server you can test this by setting the local IP (on mac run: ipconfig getifaddr en1)

  return {
    // Stores the device token in a db using node-pushserver
    // type:  Platform type (ios, android etc)
    storeDeviceToken: function(type, regId) {
	// if already not registered in api then do it 
	var LocalDeviceID =Device_id_Storage.get();	
	console.log("local device id :"+LocalDeviceID);

      // Create a random userid to store with it
      var Data = {
        type: type,
        token: regId
      };
	   var push_server_address = WORDPRESS_API_URL+"/"+$rootScope.lang_url+"/index.php?option=com_qaidi_app&task=Urls&opt=device_registration";

	 // Sending device token to server
                var postData = 'device_info='+JSON.stringify(Data);
                $http({
					method : 'POST',
					url : push_server_address,
					data: postData,
					headers : {'Content-Type': 'application/x-www-form-urlencoded'}  
                }).success(function (data, status) {
					Device_id_Storage.save(regId);
					console.log("server response:"+data.message);
				}).error(function (data, status) {
					console.log("Error storing device token." + data + " " + status);
				});			
			

	
    },
    // CURRENTLY NOT USED!
    // Removes the device token from the db via node-pushserver API unsubscribe (running locally in this case).
    // If you registered the same device with different userids, *ALL* will be removed. (It's recommended to register each
    // time the app opens which this currently does. However in many cases you will always receive the same device token as
    // previously so multiple userids will be created with the same token unless you add code to check).
    removeDeviceToken: function(token,lang_url) {
		var unpush_server_address = WORDPRESS_API_URL+"/"+lang_url+"/index.php?option=com_qaidi_app&task=Urls&opt=device_unregister";
		console.log("removing url :"+unpush_server_address);
		var Data = {token: token};
		var postData = 'device_info='+JSON.stringify(Data);
		console.log("removing  post data  :"+postData);
		$http({
					method : 'POST',
					url : unpush_server_address,
					data: postData,
					headers : {'Content-Type': 'application/x-www-form-urlencoded'}  
                }).success(function (data, status) {
					console.log("removing token server response:"+data.message);
				}).error(function (data, status) {
					console.log("Error deleting device token." + data + " " + status);
				});		


    }
	
  };
})


.factory('audio', [ '$rootScope', function ($scope) {
			/**
			 * Wrapper for HTML5 Audio class
			 * @constructor
			 */
			var AudioService = function () {
				var audio = new Audio();
				audio.preload = 'auto';
				audio.autoplay = true;

				audio.addEventListener('durationchange', function () {
					$scope.$broadcast('audio.durationchange');
				});

				audio.addEventListener('play', function () {
					$scope.$broadcast('audio.play');
				});

				audio.addEventListener('pause', function () {
					$scope.$broadcast('audio.pause');
				});

				audio.addEventListener('timeupdate', function () {
					$scope.$broadcast('audio.timeupdate');
				});

				audio.addEventListener('ended', function () {
					$scope.$broadcast('audio.ended');
				});

				/**
				 * Play current audio
				 * @returns {AudioService}
				 */
				this.play = function () {
					audio.play();

					return this;
				};
				/**
				 * Pause current audio
				 * @returns {AudioService}
				 */
				this.pause = function () {
					audio.pause();

					return this;
				};
				/**
				 * Mute sound
				 * @returns {AudioService}
				 */
				this.mute = function () {
					audio.muted = true;

					return this;
				};
				/**
				 * Unmute sound
				 * @returns {AudioService}
				 */
				this.unmute = function () {
					audio.muted = false;

					return this;
				};
				/**
				 * Get/set current audio source
				 * @param value
				 * @returns {*}
				 */
				this.source = function (value) {
					if (value === undefined) {
						return audio.currentSrc;
					}

					audio.src = value;

					return this;
				};
				/**
				 * Get/set current time in seconds
				 * @returns {Number|currentTime}
				 */
				this.currentTime = function (value) {
					if (value === undefined) {
						return audio.currentTime;
					}

					audio.currentTime = value;

					return this;
				};
				/**
				 * Get duration in seconds
				 * @returns {Number|duration}
				 */
				this.duration = function () {
					return audio.duration;
				};
				/**
				 * Return whether audio is currently paused or not
				 * @returns {boolean|paused}
				 */
				this.paused = function () {
					return audio.paused;
				};
				/**
				 * Return whether sound is currently muted or not
				 * @returns {boolean|*}
				 */
				this.muted = function () {
					return audio.muted;
				};
			};

			return new AudioService();
		} ])
		
		
		
.factory('getCats', ['$http', '$q', function($http, $q) {
  return {
    //Code edited to create a function as when you require service it returns object by default so you can't return function directly. That's what understand...
    getCats: function (type) { 
      var q = $q.defer();
      $http.get('models/settings.json').success(function (data) {
        q.resolve(function() {
          var settings = jQuery.parseJSON(data);
          return settings[type];
        });
      });
      return q.promise;
    }
  }
}])


;
